
import java.io.*;
import java.util.ArrayList;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class WikiData {
	String Totaal;
	String TEST;
	String testOmschrijving;
	boolean isEindeSmall;
	
	public static void main(String[] args) {
		
		WikiData wikiData = new WikiData();
		wikiData.start();
		
		//System.out.println("PROEF: " + WikiData.prf("Een beslissing forceren. (Afgeleid van het verhaal <a href='https: van de <a href='https://nl.wikipedia.org/wiki/Gordiaanse_knoop' title='Gordiaanse knoop'>gordiaanse knoop.)"));
		//System.out.println("PROEF: " + WikiData.prf("<dd><small>Zie: <a href=\"https://nl.wikipedia.org/wiki/Lijst_van_Nederlandse_spreekwoorden_F-J#hart\" title="
		//		+ "Lijst van Nederlandse spreekwoorden F-J\">hart</a>.</small></dd>"));
		
		//String a = "<dd><small>Zelfs met verlies van eigen leven terugvechten bij geleden onrecht.</small></dd><dd><small>Dit spreekwoord refereert aan een oudtestamentische wet (<a href=\"https://nl.wikipedia.org/wiki/Exodus_%28boek%29\" title=\"Exodus (boek)\">Exodus</a> 21:24, <a href=\"https://nl.wikipedia.org/wiki/Leviticus\" title=\"Leviticus\">Leviticus</a> 24:19-20, <a href=\"https://nl.wikipedia.org/wiki/Deuteronomium\" title=\"Deuteronomium\">Deuteronomium</a> 19:21, gecorrigeerd door de naastenliefde gepredikt door Jezus volgens <a href=\"https://nl.wikipedia.org/wiki/Evangelie_volgens_Matte%C3%BCs\" title=\"Evangelie volgens Matteus\">Mattheus</a> 5:38-39: ...Maar Ik zeg u, de boze niet te weerstaan, doch wie u een slag geeft op de rechterwang, keer hem ook de andere toe.</small></dd>";
		//String b = "<dd><small>Van het begin tot het einde; helemaal.</small></dd>"; 
		//System.out.println("PROEF: " + WikiData.filterTags(a));
	}
			
	public void start(){
		System.out.print("OPSTARTEN WIKIDATA:Start\n");
		
		// String U = "Uitdrukking/gezegde"; String S = "Nederlands spreekwoord";
		String U = "U"; String S = "S";
		String sourcePad = "D:\\GEDEELDE_MAP\\PROJECTEN\\JAVA\\workspace\\prjTest\\XXXX\\Source\\";
		//String sourcePad = "N:\\PROJECTEN\\JAVA\\workspace\\prjTest\\XXXX\\Source\\";
		
		String spel_data = "D:\\GEDEELDE_MAP\\PROJECTEN\\JAVA\\workspace\\prjTest\\XXXX\\Destination\\SPEL_DATA.TXT";
		String log = "D:\\GEDEELDE_MAP\\PROJECTEN\\JAVA\\workspace\\prjTest\\XXXX\\Destination\\log.txt";
				
		//String spel_data = "N:\\PROJECTEN\\JAVA\\workspace\\prjTest\\XXXX\\Destination\\SPEL_DATA.TXT";
		//String log = "N:\\PROJECTEN\\JAVA\\workspace\\prjTest\\XXXX\\Destination\\log.txt";
		
		openen(U, sourcePad + "Lijst van uitdrukkingen en gezegden A-E - Wikipedia.htm", spel_data,log,false);
//		openen(U, sourcePad + "Lijst van uitdrukkingen en gezegden F-J - Wikipedia.htm", spel_data, log,false);		
/* 		openen(U, sourcePad + "Lijst van uitdrukkingen en gezegden K-O - Wikipedia.htm", spel_data, log,true);
		openen(U, sourcePad + "Lijst van uitdrukkingen en gezegden P-U - Wikipedia.htm", spel_data, log,true);
		openen(U, sourcePad + "Lijst van uitdrukkingen en gezegden V-Z - Wikipedia.htm", spel_data, log,true);
		openen(S, sourcePad + "Lijst van Nederlandse spreekwoorden A-E - Wikipedia.htm", spel_data, log,true);
		openen(S, sourcePad + "Lijst van Nederlandse spreekwoorden F-J - Wikipedia.htm", spel_data, log,true);
		openen(S, sourcePad + "Lijst van Nederlandse spreekwoorden K-O - Wikipedia.htm", spel_data, log,true);
		openen(S, sourcePad + "Lijst van Nederlandse spreekwoorden P-U - Wikipedia.htm", spel_data, log,true);
		openen(S, sourcePad + "Lijst van Nederlandse spreekwoorden V-Z - Wikipedia.htm", spel_data, log,true); */
		
	}
	
	public void openen(String vraag, String source, String destination, String log, boolean append)
	{
		BufferedWriter schrijver = null;
		FileWriter logschrijver = null;
		File bestand = null;
		FileReader bestandLezer = null;
		BufferedReader lezer = null;
		
		
		String omschrijving = "";
		String antwoord = "";
		String eerdereGenoemdeOmschrijving = "";
		boolean isEindeSmall = true;
		
		try 
		{			
			schrijver = new BufferedWriter(new FileWriter(destination,append));
			logschrijver = new FileWriter(log,append);
			bestand = new  File(source);
			bestandLezer = new FileReader(bestand);
			lezer = new BufferedReader(bestandLezer);
			
			if(bestand.exists()) { System.out.println("BESTAND BESTAAT: "+ source); }
												
			System.out.println(source);
			
			schrijver.write("-------------------------------------------------------------------------------------------------------------"+"\n");			
			schrijver.write(source +"\n");
			schrijver.write("-------------------------------------------------------------------------------------------------------------"+"\n");
			
			String tt = "";
			String pp = "";
			
			if (source.contains("gezegden A")) schrijver.write("[");
			
			String regel = null;
			while ((regel = lezer.readLine())!= null)
			{	
				// Vervang rare tekens in regel
				regel = VervangRareTekensInRegels(regel);
				//Lees antwoord
				if ((regel.contains("<dd><b>")))
				{
					//Het antwoord staat op een regel
					antwoord = regel;
					omschrijving = "";
				}
				//Lees omschrijvingen; bestaat uit meerdere regels en eindigt met </small></dd>
				//Elke omschrijving kan uit meerdere omschrijvingen bestaan.
				else if (regel.contains("<dd><small>") || !isEindeSmall)
				{
					isEindeSmall = false;
					omschrijving += regel;
					if (regel.contains("</small></dd>"))
					{	
						tt= filterenTags(omschrijving);
						pp = regel;
						isEindeSmall = pp.substring(pp.length()-"</small></dd>".length()).equals("</small></dd>");
					}					
				}
				// Verwerken van vraag,antwoord en omschrijving
				else if(regel.contains("/dl>") && antwoord != "" && omschrijving != "")
				{	antwoord = filterenTags(antwoord).toUpperCase();
					omschrijving = filterenTags(omschrijving);
					
					if (omschrijving.equals("Zelfde betekenis als hierboven.")) omschrijving = eerdereGenoemdeOmschrijving;
					
					Totaal = "{\"V\":\""   + vraag + 
							 "\",\"A\":\"" + antwoord + 
							 "\",\"O\":\"" + omschrijving + "\"},"+"\n";
					
					schrijver.write(Totaal);
					eerdereGenoemdeOmschrijving = omschrijving;
					isEindeSmall = true;
					omschrijving = "";
					antwoord = "";
				}			
			} //Einde while readlines	
			
			if (source.contains("spreekwoorden V")) schrijver.write("]");
			
			lezer.close();    
			schrijver.flush();
			schrijver.close();
			logschrijver.close();		
		} //Einde try
		catch (IOException ex)
		{
			ex.printStackTrace();
		} // Einde catch

		System.out.println("-------------------------------------------------------------------");
		System.out.println("-                                                                 -");
		System.out.println("-  KLAAR......................                                    -");
		System.out.println("-                                                                 -");
		System.out.println("-------------------------------------------------------------------");
	}
	
		
    public void test(String inputString){
        List<String> a = new ArrayList<String>();
        a = splitString(inputString,14);
        System.out.println();
    }
    public static List<String> splitString(String msg, int lineSize) {
        List<String> res = new ArrayList<String>();

        Pattern p = Pattern.compile("\\b.{1," + (lineSize-1) + "}\\b\\W?");
        Matcher m = p.matcher(msg);

        while(m.find()) {
            System.out.println(m.group().trim());   // Debug
            res.add(m.group());
        }
        return res;
    }
   	
	public String VervangRareTekensInRegels(String helpRegel){
		String verwerkRegel = helpRegel;
		verwerkRegel = verwerkRegel.replaceAll("à","a");
		verwerkRegel = verwerkRegel.replaceAll("á","a");
		verwerkRegel = verwerkRegel.replaceAll("í","i");
		verwerkRegel = verwerkRegel.replaceAll("ï","i");
		verwerkRegel = verwerkRegel.replaceAll("ë","e");
		verwerkRegel = verwerkRegel.replaceAll("é","e");
		verwerkRegel = verwerkRegel.replaceAll("è", "e");
		verwerkRegel = verwerkRegel.replaceAll("ó","o");
		verwerkRegel = verwerkRegel.replaceAll("½","");
		verwerkRegel = verwerkRegel.replaceAll("ü","u");
		verwerkRegel = verwerkRegel.replaceAll("—","");		
		return verwerkRegel;
	}
		
	public String filterenTags(String proef)
	{	String helpOmschrijving = proef;
		
		//Verwijder onderstaande tags uit helpOmschrijving
		String lijstTags[] = {"<dd><small>", "</small></dd>", // helpOmschrijving = helpOmschrijving.replaceAll("\"", "'");
								"</small.></dd>", "</small.>", "</small.", "<blockquote><p><small>", "</p></blockquote><small>", "<small>", 
								"<dl>", "<dd>", "</dl>", "</dd>", "<i>", "</i>", "<b>", "</b>", "<br>", "</a>" };		
		for (String tag: lijstTags){ helpOmschrijving = helpOmschrijving.replaceAll(tag, "");}
		
		helpOmschrijving = helpOmschrijving.replaceAll("\"", "'"); //Vervang double quote door single qoute
		
		//Verwijder tag <a href
		String help;
		while (helpOmschrijving.contains("<a href='"))				  	
		{	help = helpOmschrijving.substring(0, helpOmschrijving.indexOf("<a href='"));
			if (helpOmschrijving.contains(">")) helpOmschrijving = help + helpOmschrijving.substring(helpOmschrijving.indexOf(">")+1);
		}
		
		if (! helpOmschrijving.isEmpty())
			if (!helpOmschrijving.substring(helpOmschrijving.length()-1).contains(".")
					&& !helpOmschrijving.substring(helpOmschrijving.length()-1).contains(")")) helpOmschrijving += ". ";
				
		helpOmschrijving = helpOmschrijving.replaceAll(".<br>", ".");
		helpOmschrijving = helpOmschrijving.replaceAll(".<br", ".");
		helpOmschrijving = helpOmschrijving.replaceAll("\\.", ". ");
		helpOmschrijving = helpOmschrijving.trim();
		
		return helpOmschrijving;
	}
	
	public String bewerkOFinRegels(String regel){
		int posB = regel.indexOf("</b> of <b>");
		int posSpatie;
		int posKomma;
		String zkWoord = "";
		if (posB!=-1) {
			posB +=11;
			zkWoord = regel.substring(posB);
			posKomma = zkWoord.indexOf(",");
			if(posKomma!=-1){
				zkWoord = zkWoord.substring(posKomma);
			}
			else 
			{
				posSpatie = zkWoord.indexOf(" ");
				if(posSpatie!=-1){
					//zkWoord = "KLOTE EEN SPATIE";
					zkWoord = zkWoord.substring(posSpatie);
				}
				else zkWoord = "";
			}
		}
		return zkWoord;
	}			
}
